package com.zh.test_zabbix.controller;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zh.test_zabbix.config.Config;
import com.zh.test_zabbix.model.HostItems;
import com.zh.test_zabbix.service.IHostItems;
import com.zh.test_zabbix.utils.ZabbixApi;
import lombok.Data;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/script")
public class Script {

    @Autowired
    private IHostItems host_itemsService;

    @Data
    static class argInitHostItems {
        String[] hostids;
    }

    @RequestMapping("/init")
    public Boolean initHostItems(@RequestBody argInitHostItems arg) {
        host_itemsService.initHostItems(arg.hostids);
        return true;
    }

    @Data
    static class argGraph {
        String hostid;
        int id;    // itemEnum区间
    }


    @RequestMapping("/graph")
    public ArrayList graph(@RequestBody argGraph arg){
        JSONObject res = new JSONObject();

        // 获取监控项信息
        QueryWrapper<HostItems> qw = new QueryWrapper<>();
        qw.eq("hostid", arg.hostid).eq("kind",arg.id);
        List<HostItems> list = host_itemsService.list(qw);
        if(list.size()==0){
            return null;
        }

        // 获取监控项当前值
        ArrayList<Integer> itemids = new ArrayList<>();
        for (HostItems i : list) {
            itemids.add(i.getItemid());
        }
        JSONObject param = new JSONObject();
        param.put("itemids", itemids);
        param.put("limit",itemids.size()*50);
        param.put("history",list.get(0).getValueType());
        ArrayList<String> sortfieldArr = new ArrayList<>();
        sortfieldArr.add("clock");
        param.put("sortfield",sortfieldArr);
        param.put("sortorder", "ASC");
        JSONObject itemHisResp = ZabbixApi.post("history.get", Config.AUTH, param);

        JSONArray itemHisRes = itemHisResp.getJSONArray("result");

        ArrayList<HashMap<String, String>> l = new ArrayList<>();
        HashMap<Integer, HashMap<String,Object>> mapResp = new HashMap();
        ArrayList<String> value = new ArrayList<>();
        ArrayList<String> clock = new ArrayList<>();
        for (Object i : itemHisRes) {
            JSONObject obj = (JSONObject) i;
            int itemid = obj.getIntValue("itemid");
            if(mapResp.get(itemid) == null){
                mapResp.put(itemid,new HashMap<>());
                for (HostItems ii : list) {
                    if(ii.getItemid()==itemid){
                        mapResp.get(itemid).put("name",ii.getParam());
                    }
                }
            }
            if(mapResp.get(itemid).get("value") == null){
                mapResp.get(itemid).put("value",new ArrayList<>());
            }
            if(mapResp.get(itemid).get("clock") == null){
                mapResp.get(itemid).put("clock",new ArrayList<>());
            }
            ArrayList value1 = (ArrayList) mapResp.get(itemid).get("value");
            value1.add(obj.getString("value"));
            ArrayList value2 = (ArrayList) mapResp.get(itemid).get("clock");
            value2.add(obj.getString("clock"));
        }

        ArrayList resp = new ArrayList<>();
        for (Map.Entry<Integer, HashMap<String, Object>> e : mapResp.entrySet()) {
            HashMap<String, Object> v = e.getValue();
            v.put("itemid",e.getKey());
            resp.add(v);
        }

        return resp;
    }
}
