package com.zh.test_zabbix.controller;


import com.zh.test_zabbix.service.ITriggersService;
import com.zh.test_zabbix.serviceImpl.TriggersServiceImpl;
import com.zh.test_zabbix.utils.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zh
 * @since 2023-10-26
 */
@RestController
@RequestMapping("/triggers")
public class Triggers {

    @Autowired
    private ITriggersService triggersService;

    @RequestMapping("/get")
    public Result get(@RequestBody TriggersServiceImpl.ArgGet args) {
        return triggersService.get(args);
    }

    @RequestMapping("/detail")
    public Result detail(@RequestBody TriggersServiceImpl.ArgDetail args) {
        return triggersService.detail(args);
    }

    @RequestMapping("/create")
    public Result create(@RequestBody TriggersServiceImpl.ArgCreate args) {
        return triggersService.create(args);
    }

    @RequestMapping("/delete")
    public Result delete(@RequestBody TriggersServiceImpl.ArgDelete args) {
        return triggersService.delete(args);
    }

    @RequestMapping("/update")
    public Result update(@RequestBody TriggersServiceImpl.ArgUpdate args) {
        return triggersService.update(args);
    }

    @RequestMapping("/status")
    public Result switchStatus(@Validated @RequestBody TriggersServiceImpl.ArgSwitchStatus args) {
        return triggersService.switchStatus(args);
    }



    @RequestMapping("/triggerprototype/get")
    public Result getTriggerprototype(@RequestBody TriggersServiceImpl.ArgGetTriggerprototype args) {
        return triggersService.getTriggerprototype(args);
    }

    @RequestMapping("/triggerprototype/detail")
    public Result triggerprototypeDetail(@RequestBody TriggersServiceImpl.ArgTriggerprototypeDetail args) {
        return triggersService.triggerprototypeDetail(args);
    }

    @RequestMapping("/triggerprototype/create")
    public Result triggerprototypeCreate(@RequestBody TriggersServiceImpl.ArgTriggerprototypeCreate args) {
        return triggersService.triggerprototypeCreate(args);
    }

    @RequestMapping("/triggerprototype/delete")
    public Result triggerprototypeDelete(@RequestBody TriggersServiceImpl.ArgTriggerprototypeDelete args) {
        return triggersService.triggerprototypeDelete(args);
    }

    @RequestMapping("/triggerprototype/update")
    public Result triggerprototypeUpdate(@RequestBody TriggersServiceImpl.ArgTriggerprototypeUpdate args) {
        return triggersService.triggerprototypeUpdate(args);
    }

    @RequestMapping("/triggerprototype/status")
    public Result triggerprototypeSwitchStatus(@Validated @RequestBody TriggersServiceImpl.ArgTriggerprototypeSwitchStatus args) {
        return triggersService.triggerprototypeSwitchStatus(args);
    }
}
