package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.model.Events;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-11-14
 */
public interface EventsMapper extends BaseMapper<Events> {

    @Select("<script> " +
            "SELECT " +
            "COUNT(DISTINCT e.eventid) as count " +
            "FROM events e " +
            "LEFT JOIN functions f on e.objectid=f.triggerid " +
            "LEFT JOIN items i on f.itemid=i.itemid " +
            "LEFT JOIN hosts h on i.hostid = h.hostid " +
            "WHERE 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    Integer count(@Param("ew") Wrapper<Events> qw);

    @Select("<script> " +
            "SELECT DISTINCT e.eventid,e.objectid,h.hostid,h.name hostname,e.clock,e.ns,e.name,e.severity,es1.cause_eventid " +
            ",er1.r_eventid,er1.clock r_clock " +
            "FROM events e " +
            "LEFT JOIN functions f on e.objectid=f.triggerid " +
            "LEFT JOIN items i on f.itemid=i.itemid " +
            "LEFT JOIN event_symptom es1 ON e.eventid=es1.eventid " +
            "LEFT JOIN (SELECT DISTINCT er2.eventid,e.clock,er2.r_eventid FROM events e LEFT JOIN event_recovery er2 ON " +
            "e.eventid=er2.r_eventid WHERE e.source='0' AND e.object='0' AND e.value in (0,1)) er1 ON e.eventid=er1.eventid " +
            "and e.value in (1,2) " +
            "LEFT JOIN hosts h on i.hostid = h.hostid " +
            "WHERE 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<Map> get(@Param("ew") Wrapper<Events> qw);
}
