package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.mapper.res.ResGraphHostItems;
import com.zh.test_zabbix.model.Graphs;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-11-13
 */
public interface GraphsMapper extends BaseMapper<Graphs> {

    @Select("<script> " +
            "SELECT COUNT(DISTINCT g.graphid) AS rowscount,i.hostid " +
            "FROM graphs g,graphs_items gi,items i " +
            "WHERE gi.graphid=g.graphid AND i.itemid=gi.itemid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "GROUP BY i.hostid" +
            "</script> ")
    List<Map> countHostGraphs(@Param("ew") Wrapper<Graphs> qw);

    @Select("<script> " +
            "SELECT count(DISTINCT g.graphid) " +
            "FROM graphs g,graphs_items gi,items i,hosts h " +
            "WHERE " +
            "gi.graphid=g.graphid " +
            "AND i.itemid=gi.itemid " +
            "AND h.hostid=i.hostid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    Integer count(@Param("ew") Wrapper<Graphs> qw);

    @Select("<script> " +
            "SELECT DISTINCT g.graphid,g.name,g.graphtype " +
            "FROM graphs g,graphs_items gi,items i,hosts h " +
            "WHERE " +
            "gi.graphid=g.graphid " +
            "AND i.itemid=gi.itemid " +
            "AND h.hostid=i.hostid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    ArrayList<Graphs> ids(@Param("ew") Wrapper<Graphs> qw);

    @Select("<script> " +
            "SELECT gi.graphid,i.itemid,i.name as item_name,i.value_type,h.hostid,h.name as host_name " +
            "FROM " +
            "graphs_items gi,items i,hosts h " +
            "WHERE " +
            "gi.itemid=i.itemid " +
            "AND i.hostid = h.hostid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    ArrayList<ResGraphHostItems> graphHostItems(@Param("ew") Wrapper<Graphs> qw);

    @Select("<script> " +
            "SELECT i.itemid,gd.graphid,i.name " +
            "FROM graph_discovery gd,graphs_items gi,item_discovery id,items i " +
            "WHERE " +
            "gd.parent_graphid=gi.graphid " +
            "AND gi.itemid=id.itemid " +
            "AND id.parent_itemid=i.itemid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    ArrayList<Map> graphByItemDiscovery(@Param("ew") Wrapper<Graphs> qw);

}
