package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.mapper.res.ResHistory;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.ArrayList;
import java.util.List;

public interface HistoryMapper extends BaseMapper {

    @Select("<script> " +
            "SELECT count(*) FROM " +
            " history " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    Integer count_history(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT count(*) FROM " +
            " history_str " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    Integer count_history_str(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT count(*) FROM " +
            " history_log " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    Integer count_history_log(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT count(*) FROM " +
            " history_uint  " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    Integer count_history_uint(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT count(*) FROM " +
            " history_text " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    Integer count_history_text(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT * FROM " +
            " history " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    ArrayList<ResHistory> history(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT * FROM " +
            " history_str " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    ArrayList<ResHistory> history_str(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT * FROM " +
            " history_log " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    ArrayList<ResHistory> history_log(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT * FROM " +
            " history_uint  " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    ArrayList<ResHistory> history_uint(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT * FROM " +
            " history_text " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    ArrayList<ResHistory> history_text(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT * FROM " +
            " history h " +
            "JOIN (" +
            "    SELECT itemid, MAX(clock) AS max_clock " +
            "    FROM history " +
            "    where 1=1 " +
            "    <if test='ew.nonEmptyOfWhere'>" +
            "    AND " +
            "    </if> " +
            "    ${ew.SqlSegment}" +
            "    GROUP BY itemid " +
            ") max_clocks " +
            "ON h.itemid = max_clocks.itemid AND h.clock = max_clocks.max_clock;" +
            "</script> ")
    ArrayList<ResHistory> history_list(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT * FROM " +
            " history_str h " +
            "JOIN (" +
            "    SELECT itemid, MAX(clock) AS max_clock " +
            "    FROM history_str " +
            "    where 1=1 " +
            "    <if test='ew.nonEmptyOfWhere'>" +
            "    AND " +
            "    </if> " +
            "    ${ew.SqlSegment}" +
            "    GROUP BY itemid " +
            ") max_clocks " +
            "ON h.itemid = max_clocks.itemid AND h.clock = max_clocks.max_clock;" +
            "</script> ")
    ArrayList<ResHistory> history_str_list(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT * FROM " +
            " history_log h" +
            "JOIN (" +
            "    SELECT itemid, MAX(clock) AS max_clock " +
            "    FROM history_log " +
            "    where 1=1 " +
            "    <if test='ew.nonEmptyOfWhere'>" +
            "    AND " +
            "    </if> " +
            "    ${ew.SqlSegment}" +
            "    GROUP BY itemid " +
            ") max_clocks " +
            "ON h.itemid = max_clocks.itemid AND h.clock = max_clocks.max_clock;" +
            "</script> ")
    ArrayList<ResHistory> history_log_list(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT * FROM " +
            " history_uint h " +
            "JOIN (" +
            "    SELECT itemid, MAX(clock) AS max_clock " +
            "    FROM history_uint " +
            "    where 1=1 " +
            "    <if test='ew.nonEmptyOfWhere'>" +
            "    AND " +
            "    </if> " +
            "    ${ew.SqlSegment}" +
            "    GROUP BY itemid " +
            ") max_clocks " +
            "ON h.itemid = max_clocks.itemid AND h.clock = max_clocks.max_clock;" +
            "</script> ")
    ArrayList<ResHistory> history_uint_list(@Param("ew") Wrapper qw);

    @Select("<script> " +
            "SELECT * FROM " +
            " history_text h " +
            "JOIN (" +
            "    SELECT itemid, MAX(clock) AS max_clock " +
            "    FROM history_text " +
            "    where 1=1 " +
            "    <if test='ew.nonEmptyOfWhere'>" +
            "    AND " +
            "    </if> " +
            "    ${ew.SqlSegment}" +
            "    GROUP BY itemid " +
            ") max_clocks " +
            "ON h.itemid = max_clocks.itemid AND h.clock = max_clocks.max_clock;" +
            "</script> ")
    ArrayList<ResHistory> history_text_list(@Param("ew") Wrapper qw);

    @Select("SELECT DISTINCT p.eventid,p.objectid,p.clock,p.ns,p.name,p.severity,p.cause_eventid,i.itemid,h.hostid,h.collectionid,hc.name as hc_name\n" +
            "FROM problem p,functions f,items i,hosts h,ms_host_collection hc\n" +
            "WHERE p.source='0' AND p.object='0' AND p.objectid=f.triggerid AND f.itemid=i.itemid AND i.hostid = h.hostid AND h.collectionid = hc.id AND i.hostid=10615 \n" +
            "AND p.cause_eventid IS  NULL AND p.r_eventid IS NULL\n" +
            "ORDER BY p.eventid \n" +
            "DESC LIMIT 1001")
    List problemList();

}
