package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.model.HostsGroups;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-10-24
 */
public interface HostsGroupsMapper extends BaseMapper<HostsGroups> {
    @Select("<script> " +
            "SELECT COUNT(DISTINCT h.hostid) AS rowscount,hg.groupid " +
            "FROM hosts h,hosts_groups hg " +
            "WHERE hg.hostid=h.hostid " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "GROUP BY hg.groupid"+
            "</script> ")
    List<Map<String, Object>> count(@Param("ew") Wrapper<HostsGroups> qw);

}
