package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.mapper.res.ResHostsTemplates;
import com.zh.test_zabbix.model.HostsTemplates;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-10-16
 */
public interface HostsTemplatesMapper extends BaseMapper<HostsTemplates> {

    @Select("<script> " +
            "SELECT t.hosttemplateid,h.hostid,h.name,t.templateid FROM hosts h " +
            "LEFT JOIN hosts_templates t on h.hostid = t.hostid " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<ResHostsTemplates> hostsTemplatesList(@Param("ew") Wrapper<HostsTemplates> qw);

    @Select("<script> " +
            "SELECT t.hosttemplateid,h.hostid as templateid,h.name,t.hostid FROM hosts h " +
            "RIGHT JOIN hosts_templates t on h.hostid = t.templateid " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<ResHostsTemplates> hostsParentTemplatesList(@Param("ew") Wrapper<HostsTemplates> qw);
}
