package com.zh.test_zabbix.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.test_zabbix.model.Interface;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2023-11-06
 */
public interface InterfaceMapper extends BaseMapper<Interface> {
    @Select("<script> " +
            " SELECT hi.interfaceid,hi.main,hi.type,hi.useip,hi.ip,hi.dns,hi.port,hi.available,hi.error,hi.hostid," +
            "COALESCE(his.version,2) AS version,COALESCE(his.bulk,1) AS bulk,COALESCE(his.community,'') AS community," +
            "COALESCE(his.max_repetitions,'10') AS max_repetitions,COALESCE(his.securityname,'') AS securityname," +
            "COALESCE(his.securitylevel,0) AS securitylevel,COALESCE(his.authpassphrase,'') AS authpassphrase," +
            "COALESCE(his.privpassphrase,'') AS privpassphrase,COALESCE(his.authprotocol,0) AS authprotocol," +
            "COALESCE(his.privprotocol,0) AS privprotocol,COALESCE(his.contextname,'') AS contextname " +
            "FROM interface hi " +
            "LEFT JOIN interface_snmp his ON hi.interfaceid=his.interfaceid " +
            "where 1=1 " +
            "<if test='ew.nonEmptyOfWhere'>" +
            "AND " +
            "</if> " +
            "${ew.SqlSegment}" +
            "</script> ")
    List<Map> hostsInterface(@Param("ew") Wrapper<Interface> qw);
}
